```
Project Root

└── src
    ├── app                     
        ├── scss 
            ├── blue_steel
                ├── blocks
                ├── theme.scss //imports the directory
            ├── features //represents the individual features of the application that have independent styling
                ├── about
                ├── accessibility
                ├── common
                ├── layout
                ├── login
                ├── login-recovery
                ├── mobilemarketing
                ├── provider-finder
                ├── registration
                ├── secured 
                ├── _home.scss
                ├── features.scss //imports all feature stylesheets
            ├── framework
            ├── libraries
                ├── //intended to eventually house the additional libraries in use in the application
            ├── app.scss //pulls together the theme, features, framework & overrides and the third party libraries
```

##### blue_steel
This directory is intended to house all of the general styling that otherwise does not belong to a specific feature.

The sub directory 'blocks' should be used for anything that is common to the blue steel theme but not feature specific.

##### features
Specific application features can be found here. Any new feature developed should have it's own sub directory with a matching SCSS file that is imported in the features.scss file

##### framework
The foundation framework lives in this directory. Any overrides of default foundation styles should occur in the subdirectory overrides

##### Notes
Paths in our SCSS files are relative to the final transpiled CSS file(s)

