cordova.define("cordova.plugins.diagnostic.Diagnostic", function(require, exports, module) {
/**
 *  Diagnostic plugin for Android
 *
 *  Copyright (c) 2015 Working Edge Ltd.
 *  Copyright (c) 2012 AVANTIC ESTUDIO DE INGENIEROS
 **/
var Diagnostic = function() {
  /***********************
   *
   * Internal properties
   *
   *********************/
  var Diagnostic = {};

  /*****************************
   *
   * Protected member functions
   *
   ****************************/

  Diagnostic._ensureBoolean = function(callback) {
    return function(result) {
      callback(!!result);
    };
  };

  /**
   * Opens settings page for this app.
   *
   * @param {Function} successCallback - The callback which will be called when switch to settings is successful.
   * @param {Function} errorCallback - The callback which will be called when switch to settings encounters an error.
   * This callback function is passed a single string parameter containing the error message.
   */
  Diagnostic.switchToSettings = function(successCallback, errorCallback) {
    return cordova.exec(
      successCallback,
      errorCallback,
      "Diagnostic",
      "switchToSettings",
      []
    );
  };

  /**
   * Checks if remote notifications is available to the app.
   * Returns true if remote notifications are switched on.
   *
   * @param {Function} successCallback -  The callback which will be called when the operation is successful.
   * This callback function is passed a single boolean parameter which is TRUE if remote notifications is available.
   * @param {Function} errorCallback -  The callback which will be called when the operation encounters an error.
   *  This callback function is passed a single string parameter containing the error message.
   */
  Diagnostic.isRemoteNotificationsEnabled = function(
    successCallback,
    errorCallback
  ) {
    if (cordova.plugins.diagnostic.notifications) {
      cordova.plugins.diagnostic.notifications.isRemoteNotificationsEnabled.apply(
        this,
        arguments
      );
    } else {
      throw "Diagnostic Notifications module is not installed";
    }
  };

  return Diagnostic;
};
module.exports = new Diagnostic();

});
